/******************************************************************************
 *
 *	Pocket Balloon
 *	color edition
 *	ver 1.1.0
 *	2008. 4
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#defien NOMAL
//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	XN[̏
 ***********************************************/
Err
init_screen( void )
{
  UInt16 error, hr_ref_num;
  UInt32 width = 160, height = 160, depth = 8;
  Boolean color;


  // J[T|[gĂ邩
  WinScreenMode( winScreenModeGet, NULL, NULL, NULL, &color );
  if( ! color )
    return -1;

  // SONỸnC]Cu̗L`FbN
  if( ( error = SysLibFind( sonySysLibNameHR, &hr_ref_num ) ) )
    {
      if( error == sysErrLibNotFound )
        error = SysLibLoad( 'libr', sonySysFileCHRLib, &hr_ref_num );
    }

  if( ! error )
    {
      HROpen( hr_ref_num );
      HRWinScreenMode( hr_ref_num,
                       winScreenModeGet,
                       &g_save_screen.width,
                       &g_save_screen.height,
                       &g_save_screen.depth,
                       NULL );
      // nC]ʂɂȂĂA[]ʂɕύXB
      if( g_save_screen.width == 320 )
        HRWinScreenMode( hr_ref_num, winScreenModeSet, &width, &height, NULL, NULL );
      // 8bit colorɐݒ
      WinScreenMode( winScreenModeSet, NULL, NULL, &depth, NULL);
      HRClose( hr_ref_num );
    }
  else
    {
      // nC]CuȂB
      WinScreenMode( winScreenModeGet,
                     &g_save_screen.width,
                     &g_save_screen.height,
                     &g_save_screen.depth,
                     NULL );
      WinScreenMode( winScreenModeSet, &width, &height, &depth, NULL );
    }

  // obNXN[쐬
  g_back_screen_h = WinCreateOffscreenWindow( BACK_WIDTH, BACK_HEIGHT,
                                            screenFormat, &error );
  ErrFatalDisplayIf( error, "Error Allocating Offscreen" );

  // XN[̃|C^擾
  g_back_screen_p = (UInt32 *) BmpGetBits( WinGetBitmap( g_back_screen_h ) );
  g_lcd_screen_p = (UInt32 *) BmpGetBits( WinGetBitmap( WinGetDisplayWindow() ) );

  // XN[NA
  clear_screen();

  return errNone;
}



/************************************************
 *	obNXN[LCDɃRs[
 ***********************************************/
void
copy_buff_to_lcd( void )
{
  int i;
  UInt32 *screen = g_lcd_screen_p;
  UInt32 *back = g_back_screen_p + ((BACK_WIDTH * 16 + BACK_W_BLANK) /4);


  for( i = 0; i < GAME_WIN_HEIGHT; i++)
    {
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;

      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      back += ((BACK_W_BLANK*2) / 4);	// ] 32Bytes E16dot
    }
}



/************************************************
 *	SʃNA
 ***********************************************/
void
clear_screen( void )
{
  int i;
  UInt32 color = 0xd7d7d7d7; // black (215)
  UInt32 *screen = g_back_screen_p;


  for( i = 0; i < (UInt16) (BACK_WIDTH * BACK_HEIGHT) / (8*4); i++ )
    {
      *screen++ = color;
      *screen++ = color;
      *screen++ = color;
      *screen++ = color;
      *screen++ = color;
      *screen++ = color;
      *screen++ = color;
      *screen++ = color;
    }
}



/************************************************
 *	XvCg\iobNXN[j
 *	n*nhbg 8bit XvCg
 ***********************************************/
void
sprite( Coord x, Coord y, WinHandle chr_no )
{
  int i, j, w, h;
  UInt8 *chr = BmpGetBits( WinGetBitmap( chr_no ) );
  UInt8 *screen = (UInt8 *) g_back_screen_p + (UInt16)(y * BACK_WIDTH) + x;
  RectangleType r;


  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  // TCY擾
  MemMove( &r, &(chr_no ->windowBounds), sizeof( RectangleType ) );

  h = r.extent.y; w = r.extent.x;

  for( i = 0; i < h; i++ )
    {
      for( j = 0; j < w; j++ )
        {
          if( *chr != TRANS_COLOR )
            *screen = *chr;
          screen++; chr++;
        }
      screen += BACK_WIDTH - w;
    }
}



/************************************************
 *	PSETiobNXN[j
 ***********************************************/
void
pset( Coord x, Coord y, IndexedColorType col, PsetWidthType size )
{
  UInt8 *screen = (UInt8 *) g_back_screen_p + (UInt16)(y * BACK_WIDTH) + x;


  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  *screen = col;

  if( size == bold )
    {
      *(screen + BACK_WIDTH) = col;

      pset( x-1, y, col, nomal );
    }
}



